using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Text.RegularExpressions;

/***********************************
 * ƣCuteRegexTool
 * 桡V 0.9.0
 * ߣwalkingp
 * ʱ䣺2009-11-7
 * ޸ģ2009-11-13
 * Email   walkingp@126.com
 * Bloghttp://www.51obj.cn/
 * ˵.net framework 2.0ʽ֤
 *           ʹñĴ룬עҵĿġD
 ************************************/
namespace CuteRegexTool
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();
        }

        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new frmMain());
        }

        private void frmMain_Load(object sender, EventArgs e)
        {
            InitalConfigArgument();//ʼ
        }

        #region ÷
        /// <summary>
        /// ̬ƥģʽ
        /// </summary>
        /// <returns></returns>
        private RegexOptions GetSelectRegexOption()
        {
            RegexOptions regexOptions = RegexOptions.None;
            if (chkIgnoreCase.Checked)
            {
                regexOptions |= RegexOptions.IgnoreCase;
            }
            if (chkMulti.Checked)
            {
                regexOptions |= RegexOptions.Multiline;
            }
            if (chkSingle.Checked)
            {
                regexOptions |= RegexOptions.Singleline;
            }
            if (chkPadding.Checked)
            {
                regexOptions |= RegexOptions.RightToLeft;
            }
            return regexOptions;
        }

        /// <summary>
        /// ʼ
        /// </summary>
        private void InitalConfigArgument()
        {
            rtbString.Focus();
            rtbString.Select();
            lsResult.Columns.Add("", 50, HorizontalAlignment.Left);
            lsResult.Columns.Add("ƥֵ", 200, HorizontalAlignment.Left);
            lsResult.Columns.Add("ƥλ", 150, HorizontalAlignment.Left);
            lsResult.View = View.Details;
            lsResult.FullRowSelect = true;
        }

        /// <summary>
        /// עݼ
        /// </summary>
        /// <param name="msg"></param>
        /// <param name="keyData"></param>
        /// <returns></returns>
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            switch(keyData)
            { 
                case Keys.F5:
                    RunRegex();
                    break;
                case Keys.Escape:
                    Application.Exit();
                    break;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }

        /// <summary>
        /// 
        /// </summary>
        private void RunRegex()
        {
            try
            {
                string strSourceString = rtbString.Text;

                rtbString.Clear();//ѡ
                rtbString.Text = strSourceString;

                string strRegex = txtReg.Text.Trim();
                Regex regex = new Regex(strRegex, GetSelectRegexOption());

                lsResult.Columns.Clear();
                lsResult.Items.Clear();
                lsResult.Columns.Add("", 50, HorizontalAlignment.Left);
                lsResult.Columns.Add("ƥֵ", 200, HorizontalAlignment.Left);
                lsResult.Columns.Add("ʼλ", 150, HorizontalAlignment.Left);
                lsResult.Columns.Add("λ", 150, HorizontalAlignment.Left);
                lsResult.View = View.Details;
                lsResult.FullRowSelect = true;
                
                lsResult.Click += new EventHandler(lsResult_Click);

                if (regex.IsMatch(rtbString.Text))
                {
                    MatchCollection mc = regex.Matches(rtbString.Text);

                    int arrCount = mc.Count;
                    String[] results = new String[arrCount];
                    int[] matchPosition = new int[arrCount];

                    lblResult.ForeColor = Color.Green;
                    lblResult.Text = "ƥƥɹƥ " + mc.Count + " ";

                    string stringSource = rtbString.Text;//ƥԴ
                    int startIndex = 0;//ʼ
                    int length = results.Length;//ƥ
                    for (int i = 0; i < mc.Count; i++)
                    {
                        results[i] = mc[i].Value;
                        matchPosition[i] = mc[i].Index;

                        ListViewItem item = new ListViewItem(i.ToString());
                        item.SubItems.Add(results[i].ToString());
                        item.SubItems.Add(matchPosition[i].ToString());
                        item.SubItems.Add((matchPosition[i] + results[i].Length).ToString());
                        lsResult.Items.AddRange(new ListViewItem[] { item });//ListViewʾƥ
                        if (length > 0)
                        {
                            startIndex = matchPosition[i];
                            rtbString.SelectionStart = startIndex;
                            rtbString.SelectionLength = results[i].Length;
                            if (i % 2 == 0)
                            {
                                rtbString.SelectionBackColor = Color.LightBlue;
                                rtbString.SelectionColor = Color.Black;
                            }//
                            else
                            {
                                rtbString.SelectionBackColor = Color.DarkGreen;
                                rtbString.SelectionColor = Color.White;
                            }//ż
                        }//
                    }
                }
                else
                {
                    lblResult.ForeColor = Color.Red;
                    lblResult.Text = "ƥδҵƥ";
                }
            }
            catch (ArgumentException ex)
            {
                if (txtReg.Text.Length > 1 && txtReg.Text.IndexOf("\\") > 0)
                {
                    lblResult.ForeColor = Color.Red;
                    lblResult.Text = "ϵͳִ" + ex.Message.ToString();
                }
            }
        }
        #endregion

        #region ¼
        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnRun_Click(object sender, EventArgs e)
        {
            RunRegex();
        }

        /// <summary>
        /// ˳ 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnExit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        /// <summary>
        /// ListViewѡ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void lsResult_Click(object sender, EventArgs e)
        {
            int startIndex = 0;
            int endIndex = 0;
            for (int i = 0; i < lsResult.Items.Count; i++)
            {
                if (lsResult.Items[i].Selected)
                {
                    startIndex=Convert.ToInt32(lsResult.Items[i].SubItems[2].Text);
                    endIndex = Convert.ToInt32(lsResult.Items[i].SubItems[3].Text);
                    rtbString.Select(startIndex, endIndex-startIndex);
                    rtbString.SelectionBackColor = Color.Red;
                    rtbString.SelectionColor = Color.White;
                }
            }
        }

        /// <summary>
        /// ʽ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtReg_KeyUp(object sender, KeyEventArgs e)
        {
            RunRegex();
            txtReg.Focus();
        }

        /// <summary>
        /// ˫ʽ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtReg_DoubleClick(object sender, EventArgs e)
        {
            if (copyClipBoard.Checked)
            {
                txtReg.SelectAll();
                Clipboard.SetDataObject(txtReg, true);
                MessageBox.Show("ѽʽƵ", "ʽ", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        /// <summary>
        /// ˫
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void rtbString_DoubleClick(object sender, EventArgs e)
        {
            if (copyClipBoard.Checked)
            {
                if (rtbString.Text.Trim() != "")
                {
                    rtbString.SelectAll();
                    Clipboard.SetDataObject(rtbString, true);
                    MessageBox.Show("ѽıݸƵ", "ʽ", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
            }
        }
        #endregion

        #region ˵
        private void ʽٲѯHToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Form FormRegex = new FormRegex();
            FormRegex.ShowDialog();
        }

        private void ˳EToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void ԴСдIToolStripMenuItem_Click(object sender, EventArgs e)
        {
            chkIgnoreCase.Checked =ԴСдIToolStripMenuItem.Checked;
        }

        private void ģʽհ״PToolStripMenuItem_Click(object sender, EventArgs e)
        {
            chkPadding.Checked = ģʽհ״PToolStripMenuItem.Checked;
        }

        private void RToolStripMenuItem_Click(object sender, EventArgs e)
        {
            chkLeftToRight.Checked = RToolStripMenuItem.Checked;
        }

        private void ģʽMToolStripMenuItem_Click(object sender, EventArgs e)
        {
            chkMulti.Checked = ģʽMToolStripMenuItem.Checked;
        }

        private void ģʽSToolStripMenuItem_Click(object sender, EventArgs e)
        {
            chkSingle.Checked = ģʽSToolStripMenuItem.Checked;
        }

        public frmMain(string msg)
        { 
        }

        private void ڱAToolStripMenuItem_Click(object sender, EventArgs e)
        {
            FormRegex formRegex = new FormRegex(ڱAToolStripMenuItem.Text);
            formRegex.ShowDialog();
        }

        private void chkIgnoreCase_Click(object sender, EventArgs e)
        {
            ԴСдIToolStripMenuItem.Checked = chkIgnoreCase.Checked;
        }

        private void chkPadding_Click(object sender, EventArgs e)
        {
             ģʽհ״PToolStripMenuItem.Checked =chkPadding.Checked;
        }

        private void chkLeftToRight_Click(object sender, EventArgs e)
        {
            RToolStripMenuItem.Checked = chkLeftToRight.Checked;
        }

        private void chkMulti_Click(object sender, EventArgs e)
        {
            ģʽMToolStripMenuItem.Checked = chkMulti.Checked;
        }

        private void chkSingle_Click(object sender, EventArgs e)
        {
            ģʽSToolStripMenuItem.Checked = chkSingle.Checked;
        }

        private void ҳHToolStripMenuItem_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start("http://www.51obj.cn/");
        }
        #endregion
    }
}